#!/bin/bash

#Insert path to minecraft_server.jar here
DIR=/home/programme/minecraft_server/

echo ""

case "$1" in
start)
#check if there is a screen called "minecraft"
is_it_running=`screen -ls | grep minecraft`
if [ "$is_it_running" != "" ]
then
echo "*** There is already a screen called 'minecraft' running. Aborting!"
else
echo "*** Starting minecraft-Server on screen 'minecraft'"
screen -A -m -d -S minecraft java -Xms512M -Xmx4096M -jar minecraft_server.jar nogui

#check if it is running now
status=`screen -ls | grep minecraft`
if [ "$status" == "" ]
then
echo "*** Starting failed!"
else
echo "*** Server started successfully!"
echo "*** You may now connect to console via 'screen -r minecraft'"
echo $status
fi
fi
echo ""
;;
stop)
echo "*** Looking for running minecraft-Server via 'screen'"

#check if there is a screen called "minecraft"
is_it_running=`screen -ls | grep minecraft`
if [ "$is_it_running" != "" ]
then
echo "*** Running minecraft-Server found:" $is_it_running
echo "*** Saving chunks with 'save-all'"
screen -dr minecraft -p 0 -X stuff "$(printf "save-all\r")"
echo "*** Sending message to players, that server will shutdown in 30 sec"
screen -dr minecraft -p 0 -X stuff "$(printf "say Server wird in 30sec heruntergefahren ... Wartungsarbeiten!\r")"
echo "*** Message sent. Wait 30 sec ..."
sleep 30
screen -dr minecraft -p 0 -X stuff "$(printf "say Server stoppen ...\r")"
echo ""
echo "*** Stopping" $is_it_running "now."
screen -dr minecraft -p 0 -X stuff "$(printf "stop\r")"

#wait a while and then test if screen is there
sleep 5
status_off=`screen -ls | grep minecraft`

if [ "$status_off" == "" ]
then
echo "*** minecraft-Server stopped!" $status_off
else
echo "*** Something went wrong!" $status_off
fi
else
echo "*** No screen called 'minecraft' found. Is server really running?"
fi
echo ""
;;
*)
echo $"*** Usage: $0 {start|stop}"
exit 1
esac